%global debug_package %{nil}

Epoch: 1

%define major                   8
%define minor                   2       
%define majmin                  %{major}.%{minor}
%define micro                   1
%define eclipse_base            %{_libdir}/eclipse
%define cdt_snapshot		CDT_8_2_1
%define linuxtools_snapshot	org.eclipse.linuxtools-2.1.0

# All arches line up except i386 -> x86
%ifarch %{ix86}
%define eclipse_arch    x86
%else
%ifarch %{arm}
%define eclipse_arch    arm
%else
%define eclipse_arch   %{_arch}
%endif
%endif

Summary:        Eclipse C/C++ Development Tools (CDT) plugin
Name:           eclipse-cdt
Version:        %{majmin}.%{micro}
Release:        %mkrel 3
License:        EPL and CPL
Group:          Development/Java
URL:            http://www.eclipse.org/cdt
Requires:       eclipse-platform

Source0: http://git.eclipse.org/c/cdt/org.eclipse.cdt.git/snapshot/CDT_8_2_1.tar.bz2

Source2: http://git.eclipse.org/c/linuxtools/org.eclipse.linuxtools.git/snapshot/org.eclipse.linuxtools-2.1.0.tar.bz2

# Script to run the tests in Xvnc
Source5: %{name}-runtests.sh

# Libhover docs to place locally
Source7: libstdc++-v3.libhover

Patch0: %{name}-tycho-build.patch

# Following are patches to build libhover libstdcxx plug-in and to supply
# binary libhover data directly in the plug-in itself.
Patch1: %{name}-libhover-local-libstdcxx.patch
Patch2: %{name}-libhover-libstdcxx.patch

# Following removes unused modules from libhover pom.xml
Patch3: %{name}-libhover-pom.patch

# Following fixes CDT doc plugins to use new format for tycho-extras plugin
Patch4: %{name}-doc-fix.patch

# Following removes unneeded features from Linux Tools build
Patch5: %{name}-linuxtools-features.patch

# Following adds current directory to autotools tests build.properties
Patch6: %{name}-autotools-test.patch

# Following fixes up Linux Tools top-level pom
Patch7: %{name}-linuxtools-disable-jacoco.patch

# Following removes a print stack trace from ProcessFactory spawner look-up
Patch12: %{name}-spawner-issue.patch

BuildRequires: tycho
BuildRequires: tycho-extras
BuildRequires: eclipse-pde >= 1:3.8.0
BuildRequires: eclipse-rse >= 3.3
BuildRequires: maven-local
BuildRequires: java-devel >= 1.4.2
BuildRequires: lpg-java-compat
BuildRequires: eclipse-platform >= 1:3.8.0
BuildRequires: exec-maven-plugin

Requires:       gdb make gcc-c++ autoconf automake libtool
Requires:       eclipse-platform >= 1:3.8.0
Requires:	eclipse-rse >= 3.3


%description
Eclipse features and plugins that are useful for C and C++ development.

%package parsers
Summary:        Eclipse C/C++ Development Tools (CDT) Optional Parsers
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       lpg-java-compat

%description parsers
Optional language-variant parsers for the CDT.

%package llvm
Summary:        Eclipse C/C++ Development Tools (CDT) LLVM
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       lpg-java-compat
Requires:       clang

%description llvm
Optional llvm parsers for the CDT.

%package tests
Summary:	Eclipse C/C++ Development Tools (CDT) Tests
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-llvm = %{epoch}:%{version}-%{release}
Requires:       %{name}-parsers = %{epoch}:%{version}-%{release}
Requires:       eclipse-tests

%description tests
Test plugins for the CDT.

%package sdk
Summary:        Eclipse C/C++ Development Tools (CDT) SDK plugin
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description sdk
Source for Eclipse CDT for use within Eclipse.

%prep
%setup -q -c

pushd %{cdt_snapshot}
%patch0 -p1
%patch4 -p1
%patch6 -p1
%patch12 -p1
sed -i -e 's/<arch>x86<\/arch>/<arch>%{eclipse_arch}<\/arch>/g' pom.xml
# Add secondary arch support if we are building there
%ifarch %{arm} s390 s390x
pushd core
cp -r org.eclipse.cdt.core.linux.x86 org.eclipse.cdt.core.linux.%{eclipse_arch}
pushd org.eclipse.cdt.core.linux
sed -i -e 's/<arch>x86<\/arch>/<arch>%{eclipse_arch}<\/arch>/g' pom.xml
popd
pushd org.eclipse.cdt.core.linux.%{eclipse_arch}
sed -i -e 's/x86/%{eclipse_arch}/g' pom.xml
pushd META-INF
sed -i -e 's/x86/%{eclipse_arch}/g' MANIFEST.MF
popd
pushd os/linux
mv x86 %{eclipse_arch}
popd
popd
popd
pushd releng/org.eclipse.cdt.platform-feature
sed -i -e 's/"org.eclipse.cdt.core.linux.x86"/"org.eclipse.cdt.core.linux.%{eclipse_arch}"/g' feature.xml
sed -i -e 's/arch="x86"/arch="%{eclipse_arch}"/' feature.xml
popd
sed -i -e"/<module>core\/org.eclipse.cdt.core.linux<\/module>/ a\ \t\t<module>core\/org.eclipse.cdt.core.linux.%{eclipse_arch}<\/module>" pom.xml
%endif
# Force the linux arch-specific plug-in to be a dir so that the .so files aren't loaded into
# the user.home .eclipse configuration
pushd core
pushd org.eclipse.cdt.core.linux.%{eclipse_arch}
sed -i -e"/Bundle-Localization: plugin/ aEclipse-BundleShape: dir" META-INF/MANIFEST.MF
popd
popd
popd

## Libhover stuff
tar -xaf %{SOURCE2}
pushd %{linuxtools_snapshot}

%patch5 -p0
%patch7 -p0

%pom_disable_module changelog
%pom_disable_module profiling
%pom_disable_module rpmstubby
%pom_disable_module lttng
%pom_disable_module valgrind
%pom_disable_module gcov
%pom_disable_module gprof
%pom_disable_module oprofile
%pom_disable_module systemtap
%pom_disable_module perf
%pom_disable_module rpm
popd
pushd %{linuxtools_snapshot}/libhover
# newlib libhover is an optional feature...remove it from CDT base
rm -rf org.eclipse.linuxtools.cdt.libhover.newlib
rm -rf org.eclipse.linuxtools.cdt.libhover.newlib-feature
%patch1 -p0
%patch2
%patch3 -p0
pushd org.eclipse.linuxtools.cdt.libhover.libstdcxx
mkdir data
pushd data
cp %{SOURCE7} .
popd
popd
popd

%build
export JAVA_HOME=%{java_home}

# Exclude EquinoxResolver to avoid NPE occuring on arm
%ifarch %{arm}
export MAVEN_OPTS="-XX:CompileCommand=exclude,org/eclipse/tycho/core/osgitools/EquinoxResolver,newState"
%endif

# See comments in the script to understand this.
/bin/sh -x %{eclipse_base}/buildscripts/copy-platform SDK \
  %{eclipse_base} xmlrpc codec httpclient lang rse
SDK=$(cd SDK >/dev/null && pwd)

pushd %{cdt_snapshot}
sed -i -e "s:/builddir/build/BUILD/myrepo:$repodir:g" pom.xml
popd

mkdir home
homedir=$(cd home > /dev/null && pwd)

pushd %{cdt_snapshot}
pushd core/org.eclipse.cdt.core.linux/library
make JAVA_HOME="%{java_home}" ARCH=%{eclipse_arch} CC='gcc -D_GNU_SOURCE'
popd

mvn-rpmbuild -o -DskipTychoVersionCheck -Dmaven.test.skip=true -Dtycho.local.keepTarget -fae clean install

## Libhover has dependencies on CDT so we must add these to the SDK directory
unzip -o releng/org.eclipse.cdt.repo/target/org.eclipse.cdt.repo.zip -d $SDK
popd

## Libhover build
pushd %{linuxtools_snapshot}

mkdir -p .m2/p2/repo-sdk/features
mkdir -p .m2/p2/repo-sdk/plugins
cp -d  $SDK/features/*.jar .m2/p2/repo-sdk/features
cp -d $SDK/plugins/*.jar .m2/p2/repo-sdk/plugins

mvn-rpmbuild -DskipTychoVersionCheck -Dmaven.test.skip=true -fae clean install

pushd releng/org.eclipse.linuxtools.releng-site/target/repository/features
for f in `ls -1 . | grep jar$`; do
    unzip $f -d ${f/.jar//};
    rm -fr $f
done

popd

%install
# Eclipse may try to write to the home directory.
mkdir -p home
homedir=$(cd home > /dev/null && pwd)


installDir=${RPM_BUILD_ROOT}/%{eclipse_base}/dropins/cdt
testInstallDir=${RPM_BUILD_ROOT}/%{_javadir}/eclipse-cdt-tests/plugins
parsersInstallDir=${installDir}-parsers
llvmInstallDir=${installDir}-llvm
sdkInstallDir=${installDir}-sdk
install -d -m755 $installDir
install -d -m755 $parsersInstallDir
install -d -m755 $llvmInstallDir
install -d -m755 $sdkInstallDir
install -d -m755 $testInstallDir

# Unzip contents of the cdt repo, removing all but plugins and features
unzip -q -o %{cdt_snapshot}/releng/org.eclipse.cdt.repo/target/org.eclipse.cdt.repo.zip \
-d $installDir/eclipse

#tests
# We need grep to return non-zero status to skip all non eclipse-test-plugins
pushd %{cdt_snapshot}
set +e
for pom in `find . -name pom.xml`; do
 grep -q '<packaging>eclipse-test-plugin</packaging>' ${pom}
 if [ $? -eq 0 ]; then
   testjar=`ls ${pom/pom.xml/}'target/'*.jar | grep -v sources`
   cp ${testjar} $testInstallDir
 fi
done
set -e
popd

# Add CDT core tests plugin to main package even though this isn't done upstream
cp %{cdt_snapshot}/core/org.eclipse.cdt.core.tests/target/org.eclipse.cdt.core.tests-*-SNAPSHOT.jar $installDir/eclipse/plugins

# Libhover install
unzip -q -o %{linuxtools_snapshot}/releng/org.eclipse.linuxtools.releng-site/target/org.eclipse.linuxtools.releng-site.zip \
-d $installDir/eclipse

# Unpack all existing feature jars
for x in $installDir/eclipse/features/*.jar; do
  dirname=`echo $x | sed -e 's:\\(.*\\)\\.jar:\\1:g'`
  mkdir -p $dirname
  unzip -q $x -d $dirname
  rm $x
done 

# Remove lpgjavaruntime jar file
rm -rf $installDir/eclipse/plugins/net.sourceforge.*

# Move upc, xlc, and lrparser plugins/features to parsers install area.
mkdir -p $parsersInstallDir/eclipse/features $parsersInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*xlc* $parsersInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*xlc* $parsersInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*lrparser* $parsersInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*lrparser* $parsersInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*upc* $parsersInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*upc* $parsersInstallDir/eclipse/plugins
pushd $parsersInstallDir/eclipse/plugins
ln -s ../../../../../../share/java/lpgjavaruntime.jar net.sourceforge.lpg.lpgjavaruntime_1.1.0.jar
popd

# Move llvm plugins/features to llvm install area.
mkdir -p $llvmInstallDir/eclipse/features $llvmInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*llvm* $llvmInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*llvm* $llvmInstallDir/eclipse/plugins

mkdir -p $sdkInstallDir/eclipse/features $sdkInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*source* $sdkInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*source* $sdkInstallDir/eclipse/plugins
mv $installDir/eclipse/plugins/org.eclipse.cdt.doc.isv_* $sdkInstallDir/eclipse/plugins
mv $installDir/eclipse/features/*sdk* $sdkInstallDir/eclipse/features
mv $installDir/eclipse/plugins/*sdk* $sdkInstallDir/eclipse/plugins

rm -rf $installDir/eclipse/features/org.eclipse.cdt.master_*
rm -rf $installDir/eclipse/plugins/org.eclipse.ant.optional.junit_*
rm -rf $installDir/eclipse/plugins/org.eclipse.test_*

# remove repo stuff that shouldn't be in dropins folder
rm -rf $installDir/eclipse/artifacts.jar
rm -rf $installDir/eclipse/content.jar
rm -rf $installDir/eclipse/binary

%clean
find . -type d -exec chmod u+rx {} +

%files
%{eclipse_base}/dropins/cdt
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/epl-v10.html
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/notice.html

%files sdk
%{eclipse_base}/dropins/cdt-sdk
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/epl-v10.html
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/notice.html

%files parsers
%{eclipse_base}/dropins/cdt-parsers
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/epl-v10.html
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/notice.html

%files tests
%{_javadir}/eclipse-cdt-tests
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/epl-v10.html
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/notice.html

%files llvm
%{eclipse_base}/dropins/cdt-llvm
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/epl-v10.html
%doc %{cdt_snapshot}/releng/org.eclipse.cdt.releng/notice.html



%changelog
* Thu Dec 19 2013 luigiwalser <luigiwalser> 1:8.2.1-3.mga4
+ Revision: 559005
- rebuild against eclipse-4.3.1-7.mga4

* Tue Oct 22 2013 umeabot <umeabot> 1:8.2.1-2.mga4
+ Revision: 542058
- Mageia 4 Mass Rebuild

* Mon Oct 14 2013 dmorgan <dmorgan> 1:8.2.1-1.mga4
+ Revision: 496807
- New version

* Sat Jan 19 2013 dmorgan <dmorgan> 1:8.1.1-3.mga3
+ Revision: 389587
- Rebuild against fixed eclipse

* Fri Jan 11 2013 umeabot <umeabot> 1:8.1.1-2.mga3
+ Revision: 349320
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 06 2012 dmorgan <dmorgan> 1:8.1.1-1.mga3
+ Revision: 327486
- New version

* Tue May 10 2011 pterjan <pterjan> 1:7.0.1-2.mga1
+ Revision: 96929
- Add missing Epoch

* Thu Mar 17 2011 dmorgan <dmorgan> 7.0.1-1.mga1
+ Revision: 73121
- imported package eclipse-cdt

